> ## Documentation Index
> Fetch the complete documentation index at: https://docs.codeqr.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve a list of QR Codes

> Retrieve a paginated list of QR Codes for the authenticated workspace.



## OpenAPI

````yaml get /qrcodes
openapi: 3.0.3
info:
  title: CodeQR.io API
  description: >-
    SaaS platform for creating dynamic QR Codes, trackable short links, and
    interactive pages, focused on automation, analytics, and engagement.
  version: 0.0.1
  contact:
    name: CodeQR.io Support
    email: contact@codeqr.io
    url: https://codeqr.io/api
  license:
    name: AGPL-3.0 license
servers:
  - url: https://api.codeqr.io
    description: Production API
security: []
paths:
  /qrcodes:
    get:
      tags:
        - QR Codes
      summary: Retrieve a list of QR Codes
      description: Retrieve a paginated list of QR Codes for the authenticated workspace.
      operationId: getQRCodes
      parameters:
        - in: query
          name: projectSlug
          description: >-
            The slug of the project to which the QR code belongs. For example,
            for `app.codeqr.io/acme`, the projectSlug is `acme`.
          schema:
            type: string
            description: >-
              The slug of the project to which the QR code belongs. For example,
              for `app.codeqr.io/acme`, the projectSlug is `acme`.
        - in: query
          name: domain
          description: >-
            The domain to filter the QR codes. For example, `ac.me`. If not
            provided, all QR codes of the project will be returned.
          schema:
            type: string
            description: >-
              The domain to filter the QR codes. For example, `ac.me`. If not
              provided, all QR codes of the project will be returned.
        - in: query
          name: tagId
          description: >-
            [DEPRECATED (use tagIds instead)]: The unique ID of the tag assigned
            to the QR code.
          schema:
            type: string
            description: >-
              [DEPRECATED (use tagIds instead)]: The unique ID of the tag
              assigned to the QR code.
            deprecated: true
        - in: query
          name: tagIds
          description: The IDs of the tags to filter the QR codes.
          schema:
            anyOf:
              - type: string
              - type: array
                items:
                  type: string
            description: The IDs of the tags to filter the QR codes.
        - in: query
          name: tagNames
          description: >-
            The unique name of the tags assigned to the QR code (case
            insensitive).
          schema:
            anyOf:
              - type: string
              - type: array
                items:
                  type: string
            description: >-
              The unique name of the tags assigned to the QR code (case
              insensitive).
        - in: query
          name: folderId
          description: The folder ID to filter the QR codes by.
          schema:
            type: string
            description: The folder ID to filter the QR codes by.
        - in: query
          name: search
          description: >-
            The search term to filter the QR codes. The search term will be
            matched against the QR code slug and the destination URL.
          schema:
            type: string
            description: >-
              The search term to filter the QR codes. The search term will be
              matched against the QR code slug and the destination URL.
        - in: query
          name: userId
          description: The ID of the user to filter by.
          schema:
            type: string
            description: The ID of the user to filter by.
        - in: query
          name: showArchived
          description: >-
            If should include archived QR codes in the response. The default is
            `false` if not provided.
          schema:
            type: boolean
            default: 'false'
            description: >-
              If should include archived QR codes in the response. The default
              is `false` if not provided.
        - in: query
          name: comments
          description: The comments to filter by.
          schema:
            type: string
            description: The comments to filter by.
        - in: query
          name: password
          description: The password to filter by.
          schema:
            type: string
            description: The password to filter by.
        - in: query
          name: expiresAt
          schema:
            type: string
            nullable: true
            format: date-time
            description: >-
              The date and time the QR code will expire in ISO-8601 format. Must
              be in the future.
        - in: query
          name: trackConversion
          description: >-
            If should include QR codes with conversion tracking enabled. The
            default is `false` if not provided.
          schema:
            type: boolean
            default: 'false'
            description: >-
              If should include QR codes with conversion tracking enabled. The
              default is `false` if not provided.
        - in: query
          name: withTags
          description: >-
            If should include tags in the response. The default is `false` if
            not provided.
          schema:
            type: boolean
            default: 'false'
            description: >-
              If should include tags in the response. The default is `false` if
              not provided.
        - in: query
          name: format
          description: Filter by QR code format - static or dynamic
          schema:
            type: string
            enum:
              - static
              - dynamic
            description: Filter by QR code format - static or dynamic
        - in: query
          name: type
          description: Filter by QR code type
          schema:
            type: string
            enum:
              - url
              - text
              - email
              - wifi
              - phone
              - vcard
              - crypto
              - sms
              - facetime
              - latlog
              - pix
            description: Filter by QR code type
        - in: query
          name: hasPassword
          description: Filter QR codes with/without password protection
          schema:
            type: boolean
            description: Filter QR codes with/without password protection
        - in: query
          name: hasExpiration
          description: Filter QR codes with/without expiration date
          schema:
            type: boolean
            description: Filter QR codes with/without expiration date
        - in: query
          name: hasUTM
          description: Filter QR codes with/without UTM parameters
          schema:
            type: boolean
            description: Filter QR codes with/without UTM parameters
        - in: query
          name: hasCustomSocial
          description: Filter QR codes with/without custom social media cards
          schema:
            type: boolean
            description: Filter QR codes with/without custom social media cards
        - in: query
          name: hasGeo
          description: Filter QR codes with/without geo-targeting
          schema:
            type: boolean
            description: Filter QR codes with/without geo-targeting
        - in: query
          name: hasDevice
          description: Filter QR codes with/without device targeting
          schema:
            type: boolean
            description: Filter QR codes with/without device targeting
        - in: query
          name: hasComments
          description: Filter QR codes with/without comments
          schema:
            type: boolean
            description: Filter QR codes with/without comments
        - in: query
          name: hasTags
          description: Filter QR codes with/without tags
          schema:
            type: boolean
            description: Filter QR codes with/without tags
        - in: query
          name: createdAfter
          description: Filter QR codes created after this date
          schema:
            type: string
            format: date-time
            description: Filter QR codes created after this date
        - in: query
          name: createdBefore
          description: Filter QR codes created before this date
          schema:
            type: string
            format: date-time
            description: Filter QR codes created before this date
        - in: query
          name: expiresAfter
          description: Filter QR codes expiring after this date
          schema:
            type: string
            format: date-time
            description: Filter QR codes expiring after this date
        - in: query
          name: expiresBefore
          description: Filter QR codes expiring before this date
          schema:
            type: string
            format: date-time
            description: Filter QR codes expiring before this date
        - in: query
          name: scansMin
          description: Minimum number of scans
          schema:
            type: integer
            minimum: 0
            description: Minimum number of scans
        - in: query
          name: scansMax
          description: Maximum number of scans
          schema:
            type: integer
            minimum: 0
            description: Maximum number of scans
        - in: query
          name: sort
          description: >-
            The field to order the QR codes. The default is `createdAt`, and the
            order of sorting is always descending.
          schema:
            type: string
            enum:
              - createdAt
              - scans
              - lastClicked
            default: createdAt
            description: >-
              The field to order the QR codes. The default is `createdAt`, and
              the order of sorting is always descending.
        - in: query
          name: page
          description: The page number for pagination.
          schema:
            type: number
            minimum: 0
            exclusiveMinimum: true
            default: 1
            description: The page number for pagination.
            example: 1
        - in: query
          name: pageSize
          description: The number of items per page.
          schema:
            type: number
            minimum: 0
            exclusiveMinimum: true
            maximum: 100
            default: 100
            description: The number of items per page.
            example: 50
      responses:
        '200':
          description: A list of QR Codes
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/QrCodeSchema'
        '400':
          $ref: '#/components/responses/400'
        '401':
          $ref: '#/components/responses/401'
        '403':
          $ref: '#/components/responses/403'
        '404':
          $ref: '#/components/responses/404'
        '409':
          $ref: '#/components/responses/409'
        '410':
          $ref: '#/components/responses/410'
        '422':
          $ref: '#/components/responses/422'
        '429':
          $ref: '#/components/responses/429'
        '500':
          $ref: '#/components/responses/500'
      security:
        - token: []
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Codeqr from '@codeqr/ts';

            const client = new Codeqr({
              apiKey: process.env['CODEQR_API_KEY'], // This is the default and can be omitted
            });

            const qrCodes = await client.qrcodes.list();

            console.log(qrCodes);
components:
  schemas:
    QrCodeSchema:
      type: object
      properties:
        id:
          type: string
          description: The unique ID of the QR code.
        domain:
          type: string
          description: >-
            The domain of the QR code. If not provided, the main domain of the
            project will be used (or `codeqr.link` if the project does not have
            domains).
        key:
          type: string
          description: >-
            The slug of the QR code. If not provided, a random slug of 7
            characters will be generated.
        archived:
          type: boolean
          default: false
          description: If the QR code is archived.
        expiresAt:
          type: string
          nullable: true
          description: >-
            The date and time the QR code will expire in ISO-8601 format. Must
            be in the future.
        expiredUrl:
          type: string
          nullable: true
          description: The destination URL when the QR code expires.
        password:
          type: string
          nullable: true
          description: The password required to access the destination URL of the QR code.
        externalId:
          type: string
          nullable: true
          description: The external ID associated with the QR code.
        trackConversion:
          type: boolean
          default: false
          description: '[BETA] If should track conversions for the QR code.'
        proxy:
          type: boolean
          default: false
          description: If the QR code uses the custom link preview feature.
        title:
          type: string
          nullable: true
          description: >-
            The title of the QR code generated via `api.codeqr.io/metatags`.
            Will be used for custom link preview if `proxy` is true.
        description:
          type: string
          nullable: true
          description: >-
            The description of the QR code generated via
            `api.codeqr.io/metatags`. Will be used for custom link preview if
            `proxy` is true.
        image:
          type: string
          nullable: true
          description: >-
            The image of the QR code generated via `api.codeqr.io/metatags`.
            Will be used for custom link preview if `proxy` is true.
        utm_source:
          type: string
          nullable: true
          description: The source UTM of the QR code.
        utm_medium:
          type: string
          nullable: true
          description: The medium UTM of the QR code.
        utm_campaign:
          type: string
          nullable: true
          description: The campaign UTM of the QR code.
        utm_term:
          type: string
          nullable: true
          description: The term UTM of the QR code.
        utm_content:
          type: string
          nullable: true
          description: The content UTM of the QR code.
        rewrite:
          type: boolean
          default: false
          description: If the QR code uses link cloaking.
        doIndex:
          type: boolean
          default: false
          description: If the QR code should be indexed.
        flexible:
          type: boolean
          default: false
          description: If the QR code is flexible.
        filled:
          type: boolean
          default: false
          description: If the QR code is filled.
        ios:
          type: string
          nullable: true
          description: >-
            The destination URL for iOS for the QR code for device targeting
            iOS.
        android:
          type: string
          nullable: true
          description: >-
            The destination URL for Android for the QR code for device targeting
            Android.
        geo:
          type: object
          nullable: true
          additionalProperties:
            type: string
          description: >-
            Geographic segmentation information for the QR code in the JSON
            format `{[COUNTRY]: https://example.com }`. Learn more:
            https://codeqr.link/geo
        static:
          type: boolean
          default: false
          description: If the QR code is static.
        useDisplayPage:
          type: boolean
          default: true
          description: >-
            For dynamic QR codes with phone, email, or sms types: if true
            (default), shows an action page with buttons. If false, redirects
            directly to tel:/mailto:/sms: URI.
        type:
          type: string
          enum:
            - url
            - text
            - email
            - wifi
            - phone
            - vcard
            - crypto
            - sms
            - facetime
            - latlog
            - pix
          description: The type of the QR code.
        contentStatic:
          type: string
          nullable: true
          description: The static content of the QR code.
        text:
          type: string
          nullable: true
          description: The text of the QR code.
        email:
          type: object
          nullable: true
          additionalProperties:
            type: string
          description: The email information of the QR code.
        wifi:
          type: object
          nullable: true
          additionalProperties:
            type: string
          description: The WiFi information of the QR code.
        url:
          type: string
          nullable: true
          description: The URL of the QR code.
        phone:
          type: string
          nullable: true
          description: The phone number of the QR code.
        vcard:
          type: object
          nullable: true
          additionalProperties:
            type: string
          description: The vCard information of the QR code.
        crypto:
          type: object
          nullable: true
          additionalProperties:
            type: string
          description: The cryptocurrency information of the QR code.
        sms:
          type: object
          nullable: true
          additionalProperties:
            type: string
          description: The SMS information of the QR code.
        facetime:
          type: object
          nullable: true
          additionalProperties:
            type: string
          description: The FaceTime information of the QR code.
        latlog:
          type: object
          nullable: true
          additionalProperties:
            type: string
          description: The latitude and longitude information of the QR code.
        logo:
          type: string
          nullable: true
          description: The logo of the QR code.
        bgColor:
          type: string
          description: The background color of the QR code.
        fgColor:
          type: string
          description: The foreground color of the QR code.
        size:
          type: number
          description: The size of the QR code.
        level:
          type: string
          description: The level of error correction of the QR code.
        showLogo:
          type: boolean
          default: false
          description: If the logo should be displayed in the QR code.
        src:
          type: string
          nullable: true
          description: The source of the QR code.
        height:
          type: number
          description: The height of the QR code.
        width:
          type: number
          description: The width of the QR code.
        excavate:
          type: boolean
          default: false
          description: If the QR code should be excavated.
        userId:
          type: string
          nullable: true
          description: The ID of the user that created the QR code.
        projectId:
          type: string
          nullable: true
          description: The ID of the project of the QR code.
        publicStats:
          type: boolean
          default: false
          description: If the statistics of the QR code are publicly accessible.
        scans:
          type: number
          default: 0
          description: The number of scans of the QR code.
        lastClicked:
          type: string
          nullable: true
          description: The date and time the QR code was scanned last.
        leads:
          type: number
          default: 0
          description: The number of leads generated by the QR code.
        sales:
          type: number
          default: 0
          description: The number of sales generated by the QR code.
        saleAmount:
          type: number
          default: 0
          description: The amount of the sale generated by the link.
        createdAt:
          type: string
          description: The date and time the QR code was created.
        updatedAt:
          type: string
          description: The date and time the QR code was updated last.
        tagId:
          type: string
          nullable: true
          description: >-
            [DEPRECATED (use `tags` instead)]: The unique ID of the tag assigned
            to the QR code.
          deprecated: true
        tags:
          type: array
          nullable: true
          items:
            $ref: '#/components/schemas/TagSchema'
          description: The tags assigned to the QR code.
        folderId:
          type: string
          nullable: true
          description: The unique ID of the folder assigned to the QR code.
        comments:
          type: string
          nullable: true
          description: The comments for the QR code.
        notificationToken:
          type: string
          nullable: true
          description: The notification token of the QR code.
        preRedirection:
          type: boolean
          default: false
          description: If the QR code has pre-redirection.
        pageId:
          type: string
          nullable: true
          description: The ID of the page to redirect to before the QR code destination.
        pageUrl:
          type: string
          nullable: true
          description: The URL of the page to redirect to before the QR code destination.
        isFormMandatory:
          type: boolean
          default: false
          description: If the form is mandatory for the page.
      required:
        - id
        - domain
        - key
        - archived
        - expiresAt
        - expiredUrl
        - password
        - externalId
        - trackConversion
        - proxy
        - title
        - description
        - image
        - utm_source
        - utm_medium
        - utm_campaign
        - utm_term
        - utm_content
        - rewrite
        - doIndex
        - flexible
        - filled
        - ios
        - android
        - geo
        - static
        - useDisplayPage
        - type
        - contentStatic
        - text
        - email
        - wifi
        - url
        - phone
        - vcard
        - crypto
        - sms
        - facetime
        - latlog
        - logo
        - bgColor
        - fgColor
        - size
        - level
        - showLogo
        - src
        - height
        - width
        - excavate
        - userId
        - projectId
        - publicStats
        - scans
        - lastClicked
        - leads
        - sales
        - saleAmount
        - createdAt
        - updatedAt
        - tagId
        - tags
        - folderId
        - comments
        - notificationToken
        - preRedirection
        - isFormMandatory
      title: QRCode
    TagSchema:
      type: object
      properties:
        id:
          type: string
          description: The unique ID of the tag.
        name:
          type: string
          description: The name of the tag.
        color:
          type: string
          enum:
            - red
            - yellow
            - green
            - blue
            - purple
            - pink
            - brown
          description: The color of the tag.
      required:
        - id
        - name
        - color
      title: Tag
  responses:
    '400':
      description: >-
        The server cannot or will not process the request due to something that
        is perceived to be a client error (e.g., malformed request syntax,
        invalid request message framing, or deceptive request routing).
      content:
        application/json:
          schema:
            x-speakeasy-name-override: BadRequest
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - bad_request
                    description: A short code indicating the error code returned.
                    example: bad_request
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#bad-request
                required:
                  - code
                  - message
            required:
              - error
    '401':
      description: >-
        Although the HTTP standard specifies "unauthorized", semantically this
        response means "unauthenticated". That is, the client must authenticate
        itself to get the requested response.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: Unauthorized
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - unauthorized
                    description: A short code indicating the error code returned.
                    example: unauthorized
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#unauthorized
                required:
                  - code
                  - message
            required:
              - error
    '403':
      description: >-
        The client does not have access rights to the content; that is, it is
        unauthorized, so the server is refusing to give the requested resource.
        Unlike 401 Unauthorized, the client's identity is known to the server.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: Forbidden
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - forbidden
                    description: A short code indicating the error code returned.
                    example: forbidden
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#forbidden
                required:
                  - code
                  - message
            required:
              - error
    '404':
      description: The server cannot find the requested resource.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: NotFound
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - not_found
                    description: A short code indicating the error code returned.
                    example: not_found
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#not-found
                required:
                  - code
                  - message
            required:
              - error
    '409':
      description: >-
        This response is sent when a request conflicts with the current state of
        the server.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: Conflict
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - conflict
                    description: A short code indicating the error code returned.
                    example: conflict
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#conflict
                required:
                  - code
                  - message
            required:
              - error
    '410':
      description: >-
        This response is sent when the requested content has been permanently
        deleted from server, with no forwarding address.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: InviteExpired
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - invite_expired
                    description: A short code indicating the error code returned.
                    example: invite_expired
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#invite-expired
                required:
                  - code
                  - message
            required:
              - error
    '422':
      description: >-
        The request was well-formed but was unable to be followed due to
        semantic errors.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: UnprocessableEntity
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - unprocessable_entity
                    description: A short code indicating the error code returned.
                    example: unprocessable_entity
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.codeqr.io/api-reference/errors#unprocessable-entity
                required:
                  - code
                  - message
            required:
              - error
    '429':
      description: >-
        The user has sent too many requests in a given amount of time ("rate
        limiting")
      content:
        application/json:
          schema:
            x-speakeasy-name-override: RateLimitExceeded
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - rate_limit_exceeded
                    description: A short code indicating the error code returned.
                    example: rate_limit_exceeded
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.codeqr.io/api-reference/errors#rate-limit_exceeded
                required:
                  - code
                  - message
            required:
              - error
    '500':
      description: The server has encountered a situation it does not know how to handle.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: InternalServerError
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - internal_server_error
                    description: A short code indicating the error code returned.
                    example: internal_server_error
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.codeqr.io/api-reference/errors#internal-server_error
                required:
                  - code
                  - message
            required:
              - error
  securitySchemes:
    token:
      type: http
      description: Default authentication mechanism
      scheme: bearer

````